<?php
function d($var) { 
	print_r( $var);
	print "<br />";
}

function IterateLibraryDirectory(
	$mysqli, 
	$directory,
        $callback,	
	$filetypes = array("chm", "pdf", "html", "htm"), 
	$purgeUnknownFiles = FALSE) {
		if(!$current_dir = opendir($directory))
			trigger_error("Library directory doesn't exist", E_USER_ERROR);
		// get each entry
		while($entryName = readdir($current_dir)) {
			if($entryName == "." || $entryName == "..") continue;
			$spl_file = explode(".", $entryName);
			if(is_dir($directory . "/" . $entryName)) { 
				// index it and log dir ctime
				if(!call_user_func(
					$callback,
					$mysqli,
					$directory . "/" . $entryName, 
					"dir",
					filectime($directory . "/" . $entryName)))
						throw new Exception("user callback returned false or an error occured.");
				IterateLibraryDirectory(
					$mysqli,
					$directory . "/" . $entryName,
				        $callback,	
					$filetypes);
				continue;
			}
			else if(in_array(
				strtolower($spl_file[count($spl_file)-1]),
				$filetypes)) {
					if(!call_user_func(
						$callback,
						$mysqli, 
						$directory . "/" . $entryName, 
						$spl_file[count($spl_file)-1],
						filectime($directory . "/" . $entryName)))
							throw new Exception("user callback returned false or an error occured.");
				}
		}
}
?>
